
public class Bsp1 {

    public static void main(String[] args) {

        Bsp1Vars v = new Bsp1Vars();

        for (int i = 0; i < 10; i++ ) {
            v.init();
	    Thread t1 = new Thread( new Bsp1Action1(v) );
	    Thread t2 = new Thread( new Bsp1Action2(v) );
	    Thread t3 = new Thread( new Bsp1Action3(v) );

            t1.start(); t2.start(); t3.start();

            try {
                  t1.join(); t2.join(); t3.join();
            } 
            catch (InterruptedException e) { }

            System.out.println("x = " + v.x + ", y = " + v.y + ", z = " + v.z);
	}

    }

}

class Bsp1Action1 implements Runnable {

    private Bsp1Vars v;

    Bsp1Action1( Bsp1Vars w ) { v = w; }

    public void run() { 
        Work.schaffen(100);
        v.z = v.x + v.y; 
    }

}

class Bsp1Action2 implements Runnable {

    private Bsp1Vars v;

    Bsp1Action2( Bsp1Vars w ) { v = w; }

    public void run() { 
        Work.schaffen(100);
        v.x = v.x + 1;
    }
}

class Bsp1Action3 implements Runnable {

    private Bsp1Vars v;

    Bsp1Action3( Bsp1Vars w ) { v = w; }

    public void run() {
        Work.schaffen(100);
        v.y = v.y + 2;
    }
}

class Bsp1Vars {

    public int x;
    public int y;
    public int z;

    public void init() {
        x = 0; y = 0; z = 0;
    }

}
