
public class Bsp2 {

    public static void main(String[] args) {

        Bsp2Vars v = new Bsp2Vars();

        for (int i = 0; i < 10; i++ ) {
            v.init();
	    Thread t1 = new Thread( new Bsp2Action1(v) );
	    Thread t2 = new Thread( new Bsp2Action2(v) );

            t1.start(); t2.start(); 

            try {
                  t1.join(); t2.join();
            } 
            catch (InterruptedException e) { }

            System.out.println("x = " + v.x + ", y = " + v.y + ", z = " + v.z);
	}

    }

}

class Bsp2Action1 implements Runnable {

    private Bsp2Vars v;

    Bsp2Action1( Bsp2Vars w ) { v = w; }

    public void run() { 
            Work.schaffen(100);
        synchronized(v) {
            Work.schaffen(300);
            v.z = v.x + v.y; 
	}
    }

}

class Bsp2Action2 implements Runnable {

    private Bsp2Vars v;

    Bsp2Action2( Bsp2Vars w ) { v = w; }

    public void run() { 
        synchronized(v) {
            Work.schaffen(10);
            v.x = v.x + 1;
            Work.schaffen(100);
            v.y = v.y + 2;
	}
    }
}

class Bsp2Vars {

    public int x;
    public int y;
    public int z;

    public void init() {
        x = 0; y = 0; z = 0;
    }

}
