/**
 * Hello World Client
 *
 */

import java.io.*;
import java.net.*;

public class HelloWorldClient {

    static int port = 40000;
    static String host = "localhost";
    static String msg = "Hallo Welt";

    public static void main(String[] args) {

        if (args.length > 0) host = args[0];
        if (args.length > 1) msg = args[1];

        Integer x = new Integer(4711);

	try {
            Socket s = new Socket( host, port );
	    System.out.println("Client connected to Server");

            SocketChannel c = new SocketChannel(s);

            c.send( msg );
            c.send( x );

            c.close();

	} catch (IOException e) {
	    System.out.println("IOException "+e);
	}

    }


}
