public class KontoB {

    private double stand; // Konto Stand

    public KontoB() { stand = 0.0; }

    public KontoB(double a) { stand = a; }

    public synchronized double zeigeGeld() { return stand; }

    public synchronized double putGeld(double b) { // stand += b
	double s = stand + b;
        Work.schaffen(100);
        // nur falls s >= 0
	while (s < 0 && stand > s) {
        	try { 
  	            this.wait();       
	        } catch(InterruptedException e) { } 
                s = stand + b;
	}
        if (s >= 0 || s > stand) this.notify();
        stand = s;
        return s;   
    }

    public synchronized double getGeld(double b) { // stand -= b
	double s = stand - b;
        Work.schaffen(100);
        // nur falls s >= 0
	while (s < 0 && stand > s) {
        	try { 
  	            this.wait();       
	        } catch(InterruptedException e) { } 
                s = stand - b;
	}
        if (s >= 0 || s > stand) this.notify();
        stand = s;
        return s;   
    }

}

class Work {
    public static void schaffen(int max) {
	try {
            Thread.currentThread().sleep( (int)(max*Math.random()) );
        } catch (InterruptedException e) {
              System.out.println("Dies sollte nicht passieren "+e);
	}
    }
}
