/**
 * Sequential Matrix Multiplication 
 */


public class SeqMult implements MMInf {

/**
 * Performs the multiplication of two matrices.
 * @param C, A, B Arrays.
 */
    public void multiply(double[][] C, double[][] A, double[][] B) {
      for (int i=0; i < A.length; i++) {
          for (int j=0; j < B[0].length; j++) {
              double c = 0.0;
              for (int k=0; k < B.length; k++) {
                  c += A[i][k] * B[k][j];
              }
              C[i][j] = c;
          }
      }
    }

}
