/**
 * Buchungen im Netz bearebiten
 */

import java.io.IOException;

public class NetzBuchungBuche {

    private static int anzahl = 0;
    private static ChannelFactory cf = null;
    private static SocketChannel channel = null;
    private final static String finis = "finis";

    private static KontoS [] konten;
    private static int kmax;
    private static int umax = 300;

    public static void main(String[] args) throws InterruptedException {

        final int kmax = 30;
        KontoS[] konten = new KontoS[kmax]; 
        double balance = 0.0;
        double stand;

        for (int i = 0; i < kmax; i++) {
            konten[i] = new KontoS( 5000 );
	    stand = konten[i].zeigeGeld();
            balance += stand;
            System.out.println("Kontostand i = " + i 
                             + " Betrag = " + konten[i].zeigeGeld() );
        }
        System.out.println("Balance " + balance); 

        cf = new ChannelFactory(30000); 


	while (true) {

           channel = cf.getChannel();

           System.out.println("Starting ... ");
           Object o = null;
	   for ( ; ; ) {
               anzahl++;
	       //               System.out.println("channel.recieve = " + anzahl );

               try { o = channel.receive(); }
               catch (IOException e) {
                     System.err.println(e); return; }
               catch (ClassNotFoundException e) {
                     System.err.println(e); return; }

               if ( o instanceof String ) { 
                  String os = (String) o;
                  if ( os.equals(finis) ) break; 
	       }
	       UeberweisungS u = (UeberweisungS) o;
               u.run(konten);
           }
           System.out.println("... finished " + anzahl + " records.");

        balance = 0.0;
        for (int i = 0; i < kmax; i++) {
	    stand = konten[i].zeigeGeld();
            balance += stand;
            System.out.println("Kontostand i = " + i 
                             + " Betrag = " + konten[i].zeigeGeld() );
        }
        System.out.println("Balance " + balance); 

	}
    }

}
