/** 
 * Recursion Tasks
 *
 * see FJTask by Lea
 *
 */

//package edu.unima.ky.parallel;


public abstract class RecursionTask  {

    private Semaphore done = new Semaphore(0);
    private RecursionThreads mythread = null;


    public boolean isDone() {
	return done.isPositive();
    }


    public void waitDone() throws InterruptedException {
	done.P();
    }


    public void runit() {
        compute();
	done.V();
    }


    public abstract void compute();


    public void setThread(RecursionThreads t) {
	mythread = t;
    }


    public  void concurrent(RecursionTask t1, RecursionTask t2) {
        mythread.concurrent(t1,t2);
    }


    public  void concurrent(RecursionTask[] t) {
        mythread.concurrent(t);
    }


}

